#include <stdint.h>
#include <stdio.h>
#include <curl/curl.h>
#include <time.h>
#include <string.h>
#include <unistd.h>


const char INFLUXURL[] = "https://home.hottis.de/influx/write?db=smarthome2&precision=ms";
const char INFLUXUSER[] = "secundus";
const char INFLUXPASS[] = "geheim";

// #define BUFSIZE 131070
#define BUFSIZE 65535
// #define BUFSIZE 1024
char influxBuffer[BUFSIZE];
char *bufferNextEntry;

#define HOSTNAMESIZE 128
char hostname[HOSTNAMESIZE];

void influxInit() {
    memset(influxBuffer, 0, BUFSIZE);
    bufferNextEntry = influxBuffer;
    gethostname(hostname, HOSTNAMESIZE);
}

static void influxSendRequest() {
    CURL *curl = curl_easy_init();
    if(curl) {
        curl_easy_setopt(curl, CURLOPT_URL, INFLUXURL);
        curl_easy_setopt(curl, CURLOPT_HTTPAUTH, CURLAUTH_DIGEST);
        curl_easy_setopt(curl, CURLOPT_USERNAME, INFLUXUSER);
        curl_easy_setopt(curl, CURLOPT_PASSWORD, INFLUXPASS);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, influxBuffer);
        CURLcode res = curl_easy_perform(curl);
        if(res != CURLE_OK) {
            fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
        }
        curl_easy_cleanup(curl);
    }
}

void influxAddFrequency(double f) {
    static uint32_t entries = 0;
    static uint32_t totalEntries = 0;
    char tmpBuf[256];
    struct timespec t;

    clock_gettime(CLOCK_REALTIME, &t);
    uint64_t tt = (((uint64_t)t.tv_sec) * 1000) + (((uint64_t)t.tv_nsec) / 1000000);
    int c = sprintf(tmpBuf, "mainsfrequency,host=%s freq=%f %llu\n", hostname, f, tt);

    if ((bufferNextEntry + c + 10) > (influxBuffer + BUFSIZE)) {
        influxSendRequest();
        influxInit();
        totalEntries += entries;
        fprintf(stderr, "%u entries sent to database, in total %u\n", entries, totalEntries);
        entries = 0;
    }

    memcpy(bufferNextEntry, tmpBuf, c);
    bufferNextEntry += c;
    entries++;
}


